
# About

The header-only part of the Lol Engine framework.

| header | category | description |
|--------|:--------:|-------------|
| `<lol/cli>`       | system | command-line parsing |
| `<lol/dialogs>`   | system | portable file dialogs (imported from [here](https://github.com/samhocevar/portable-file-dialogs)) |
| `<lol/file>`      | system | file reading utilities |
| `<lol/msg>`       | system | simple message logging |
| `<lol/thread>`    | system | threading and timers |
| `<lol/unit_test>` | system | unit test framework |
| `<lol/utils>`     | system | various utilities: environment variables, string formatting, std::map and std::vector extensions… |
| `<lol/narray>` | containers | n-dimensional dynamic array container |
| `<lol/pegtl>`             | text | the PEGTL parsing library (imported from [here](https://github.com/taocpp/PEGTL) |
| `<lol/algo/suffix_array>` | text | suffix array library (imported from [here](https://github.com/storm-ptr/step) |
| `<lol/color>` | graphics | color conversions |
| `<lol/image>` | graphics | image loading, saving, and processing |
| `<lol/bigint>`    | math | big integer calculations |
| `<lol/half>`      | math | half-precision (16-bit) floating point numbers |
| `<lol/math>`      | math | math constants, functions, random number generators, polynomials |
| `<lol/noise>`     | math | Perlin and simplex noise |
| `<lol/real>`      | math | arbitrary precision floating point numbers |
| `<lol/transform>` | math | quaternion, matrix and SQT transformation utilities |
| `<lol/vector>`    | math | GLSL-compatible vector classes |

